/*
 * Created on 5/Fev/2005
 * @author jls
 */

import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import java.rmi.server.*;
import java.io.*;

import java.util.*;

public aspect Distribution {
	
	//interfaces and upper classes about RMI
	declare parents: CalcPi implements ICalcPi;
	//declare parents: CalcPi extends RemoteObject;

	//main function. Registers server im RMI
	public static void CalcPi.main(String args[]) {
	    try {
	      CalcPi pf = new CalcPi();
	      PortableRemoteObject.exportObject(pf);
	      Context ctx = new InitialContext();
	      ctx.rebind(args[0],pf); 

	      // Wait for shutdown
	      BufferedReader rdr = new BufferedReader(new InputStreamReader(System.in));
	      while (true) {
	        System.out.println("Type EXIT to shutdown the server");
	        if ("EXIT".equals(rdr.readLine())) { break; }
	      }
	      ctx.unbind(args[0]);
	      PortableRemoteObject.unexportObject(pf);
	    } catch(Exception e) { e.printStackTrace(); }
	}
		
	int conta=0;
	HashMap remotes = new HashMap();
	
	Object around() : call (CalcPi.new(..)) && !within(Distribution) {
//		System.out.println("new CalcPi");
		String name=new String("PS"+(++conta));
//	  	System.out.println("Localizar " + name);
	  	ICalcPi remote=null; 
	  	try {
	  		Context ctx = new InitialContext();
			remote = (ICalcPi) PortableRemoteObject.narrow(ctx.lookup(name), ICalcPi.class);
		} catch(Exception ex) {  ex.printStackTrace();   }
		  	
//		System.out.println("Localizar OK");
		// para corrijir  problema na converso de tipos
		CalcPi local = new CalcPi();
//		System.out.println("Local=" + local + " Remote=" + remote);
		remotes.put(local,remote);
		return(local);
	}
		
	MyDouble around(CalcPi obj, double min, double max, double passo): call(* *.PCalc(..)) && args(min,max,passo) && !within(Distribution) && target(obj) {
//		System.out.println("Calling remote PCalc " + min + " .. " + max);
		MyDouble res = null;
		try{
			res = ((ICalcPi) remotes.get(obj)).PCalc(min,max,passo);
		}catch (Exception e){e.printStackTrace();}
		return(res);
	}
}

