/*
 * Created on 28/Mai/2005
 * @author jls
 */

import java.util.*;

public aspect Partition {
	static int workers = 4;
	Vector<CalcPi> farm = new Vector<CalcPi>();
		
	CalcPi around() : call (CalcPi.new()) && within(Client*) {
		for(int i=0; i<workers; i++) {
			CalcPi rt = new CalcPi(); //proceed();
			farm.add(rt);
			//System.out.println(rt + " " + i + " worker created");			
		}
		return((CalcPi)farm.get(0));
	}

	double around(CalcPi obj, double min, double max, double step) : call(* *.calc(double,double,double)) && target(obj) && args(min,max,step) && within(Client*) {

		//Vector<Double> res = new Vector<Double>();
		Vector<MyDouble> res = new Vector<MyDouble>();
		int n = (int) (max-min);
		
		// invocar os vrios trabalhadores
		for(int p=0; p<workers; p++) {
    		//System.out.println("calc " + p + " " + farm.elementAt(p));
     		CalcPi pc =  ((CalcPi) farm.elementAt(p));
    		res.add(pc.PCalc( p*(n/workers),(p+1)*(n/workers),step)); 
     		//res.add(pc.calc( p*(n/workers),(p+1)*(n/workers),step));
		}

		// juntar os resultados
		double taprox = 0;
		for(int j=0; j<workers; j++) {
			taprox += ((MyDouble) res.elementAt(j)).doubleValue(); 
			//taprox += res.elementAt(j); 
		}
		return(taprox);
	}
	
	// Transformar o valor de retorno da funo calcPI num array de double
	public MyDouble/*double[]*/ CalcPi.PCalc(double min, double max, double passo) {
			MyDouble aux = new MyDouble(calc(min,max,passo));
		return(aux);
	}
}
